#include <stdio.h>
#include <comedilib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <errno.h>

void help(void)
{
	fprintf(stderr,"info <file>\n");
	exit(0);
}

char *flagstring[]={"rw","ro","rw,shared","ro,shared"};
char *pnumstring[]={"input/output","analog/digital","# of bits",
	"max data","voltage range","last data","last data sec",
	"last data nsec","deglitch","other" };

void main(int argc,char *argv[])
{
	int i,j,ret;
	int it;
	comedi_info info;
	comedi_param param;
	
	if(argc!=2)help();

	it=open(argv[1],O_RDWR);
	if(!it){
		fprintf(stderr,"cannot open %s\n",argv[1]);
		exit(0);
	}

	comedi_getinfo(it,&info);
	
	printf("overall info:\n");
	printf("  minor: %d\n",info.minor);
	printf("  iobase: 0x%04x\n",info.iobase);
	printf("  iosize: 0x%04x\n",info.iosize);
	printf("  irq: %d\n",info.irq);
	printf("  nnumber of channels: %d\n",info.chan);
	
	for(i=0;i<info.chan;i++){
		printf("channel %d:\n",i);
		j=0;
		for(;;){
			param.chan=i;
			param.pnum=j;
			ret=ioctl(it,COMEDI_GETNPARAM,&param);
			if(ret<0)break;
	
			/*hack*/
			if(param.pnum==COMEDI_DEGLITCH)param.pnum=
				COMEDI_LASTNSEC+1;
			if(param.pnum>COMEDI_LASTNSEC+1)param.pnum=
				COMEDI_LASTNSEC+2;
			
			printf("    %s: %d (%s)\n",
				pnumstring[param.pnum],
				param.pval,
				flagstring[param.flags]);
			j++;
		}
	}
}

